HDU-1072 Nightmare (DFS+剪枝)

3 篇文章 0 订阅

debug到我想吐,找了几个小时的bug,真的是难受。

题目传送门

 

Nightmare

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 14495    Accepted Submission(s): 7039


 

Problem Description

Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius' start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can't get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can't use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.

 

 

Input

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius' start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius' target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.

 

Output

For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.

 

 

Sample Input

3 3 3 2 1 1 1 1 0 1 1 3 4 8 2 1 1 0 1 1 1 0 1 0 4 1 1 0 4 1 1 0 0 0 0 0 0 1 1 1 1 4 1 1 1 3 5 8 1 2 1 1 1 1 1 4 1 0 0 0 1 0 0 1 1 4 1 0 1 1 0 1 1 0 0 0 0 3 0 1 1 1 4 1 1 1 1 1

 

 

Sample Output

4 -1 13

 

题目大意:

迷宫问题,在炸弹爆炸(6second)之前找到出口,有点不一样的地方是迷宫中存在一种重置计时装置可以使得炸弹时间重置.在n×m的地图上,0表示墙,1表示空地,2表示人,3表示目的地,4表示有定时炸弹重启器。定时炸弹的时间是6,人走一步所需要的时间是1。每次可以上、下、左、右移动一格。当人走到4时如果炸弹的时间不是0,可以重新设定炸弹的时间为6。

我们需要输出最短逃出时间,如果无法逃出则输出-1.

 

思路:

我一开始想DFS就完事儿了,但是发现会tle,所以需要对算法进行剪枝。

剪枝的思路:

某些结点会重复走过,比如有4的结点。但其实我们的最优解是在第一次经过这个结点就已经产生了,第二次经过这个结点后总步数肯定是大于原步数的,此时若剩余的时间少于原时间则不走这条路

    //void dfs(int x,int y,int cost,int rest)
    //cost是花费的时间,rest是剩余的时间	
	//枝剪,走已经走过的路 
    //枝剪,走已经走过的路,重复走过一个点之后步数是增加的,此时不会是最优解 
    //此时若剩余时间少于原有时间则不走 
    if(cost>=step[x][y] && rest<=time[x][y])
        return ; 
    step[x][y]=cost;		//更新该步的消耗时间和剩余时间 
    time[x][y]=rest;

 

完整代码:

#include<cstring>
#include<algorithm>
#include<cstdio>
#define inf 0x3f3f3f3f
using namespace std;
int map[9][9],vis[9][9],N,M,tt,flag;
int sx,sy,ex,ey;
int move_[4][2]={ {-1,0},{1,0},{0,-1},{0,1} };
int step[9][9],time[9][9];

void dfs(int x,int y,int cost,int rest){  //cost是花费的时间,rest是剩余的时间 
    
    int dx,dy;
    if(x<0||x>=N||y<0||y>=M||rest<=0||map[x][y]==0) 
            return ;
/*
    if(rest<=0 && (x!=ex||y!=ey)){  //到时间了却没有到终点 
        tt=-1;
        return ;
    }*/
    if(x==ex && y==ey) { //成功到达终点 
        flag=1;
        tt=min(tt,cost);
        return ;
    }
    if(map[x][y]==4)        //未到爆炸时间则重置时间 
        rest=6;            
   
    //枝剪,走已经走过的路,重复走过一个点之后步数是增加的,此时不会是最优解 
    //此时若剩余时间少于原有时间则不走 
    if(cost>=step[x][y] && rest<=time[x][y])
        return ; 
    step[x][y]=cost;		//更新该步的消耗时间和剩余时间 
    time[x][y]=rest;
        
    for(int i=0;i<4;i++){
        dx=x+move_[i][0];	
        dy=y+move_[i][1];
        dfs(dx,dy,cost+1,rest-1);    
    }
    /* 
	dfs(x,y-1,sum+1,T-1);//左 
    dfs(x,y+1,sum+1,T-1);//右 
    dfs(x-1,y,sum+1,T-1);//下 
    dfs(x+1,y,sum+1,T-1);//上 */ 
}




int main(){
    int T;
    scanf("%d",&T);
    while(T--){
    scanf("%d%d",&N,&M);
        for(int i=0;i<N;i++){
        getchar();
        for(int j=0;j<M;j++){
            scanf("%d",&map[i][j]);
            
            time[i][j]=0;      	  //不要忘记初始化 !! 
            step[i][j]=inf;       
            
            if(map[i][j]==2){     //记录起点 
            sx=i;
            sy=j;        
            }
            if(map[i][j]==3){
            ex=i;
            ey=j;
            }    
        }
        }
    flag=0;
    tt=inf;
    dfs(sx,sy,0,6);

    if(flag==1)
    printf("%d\n",tt);
    else
    printf("-1\n",tt);
    }
    return 0;
} 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值